#!/usr/sbin/nft -f

flush ruleset

table ip nat {
    chain PREROUTING {
        type nat hook prerouting priority 0; policy accept;

        iif lo accept comment "Accept any localhost traffic";
        ct state invalid drop comment "Drop invalid connections";
        ct state established,related accept comment "Accept traffic originated from us";

{% for machine in machines |dict2items %}
{%   for proto in machine.value.net_config.publish_ports %}
{%     for port in machine.value.net_config.publish_ports[proto] %}
{%       set out_port = (port |string).split( ':' )[0] %}
{%       set in_port  = (port |string).split( ':' )[1] |d(port |string) %}
{%       if 'address' in machine.value.net_config %}
        iif "{{ net_config.wan_if }}" {{ proto }} dport {{ out_port }} counter dnat to {{ machine.value.net_config.address |ipv4('address') }}:{{ in_port }};
{%       endif %}
{%     endfor %}
{%   endfor %}
{% endfor %}       
    }

    chain POSTROUTING {
        type nat hook postrouting priority 100; policy accept;

        oif "{{ net_config.wan_if }}" ip saddr {{ net_config.net }} counter masquerade
    }
}

table ip6 nat {
    chain PREROUTING {
        type nat hook prerouting priority 0; policy accept;

{% for machine in machines |dict2items %}
{%   for proto in machine.value.net_config.publish_ports %}
{%     for port in machine.value.net_config.publish_ports[proto] %}
{%       set out_port = (port |string).split( ':' )[0] %}
{%       set in_port  = (port |string).split( ':' )[1] |d(port |string) %}
{%       if 'address6' in machine.value.net_config %}
        iif "{{ net_config.wan_if }}" {{ proto }} dport {{ out_port }} counter dnat to {{ machine.value.net_config.address6 |ipv6('address') |ipv6('wrap') }}:{{ in_port }};
{%       endif %}
{%     endfor %}
{%   endfor %}
{% endfor %}       
    }

    chain POSTROUTING {
        type nat hook postrouting priority 100; policy accept;

        oif "{{ net_config.wan_if }}" ip6 saddr {{ net_config.net6 }} counter masquerade;
    }
}

table inet filter {
    chain INPUT {
        type filter hook input priority 0; policy accept;

{% for machine in machines |dict2items %}
{%   for proto in machine.value.net_config.publish_ports %}
{%     for port in machine.value.net_config.publish_ports[proto] %}
{%       set out_port = (port |string).split( ':' )[0] %}
{%       set in_port  = (port |string).split( ':' )[1] |d(port |string) %}
        iif "{{ net_config.wan_if }}" {{ proto }} dport {{ out_port }} counter accept comment "port forwarding for {{ machine.key }}";
{%     endfor %}
{%   endfor %}
{% endfor %}
        # enable ssh access
{% if ansible_port |d(False) %}
{%   if ansible_default_ipv4 %}
        iif "{{ net_config.wan_if }}" ip daddr {{ ansible_default_ipv4.address }} tcp dport {{ ansible_port }} counter accept;
{%   endif %}
{%   if ansible_default_ipv6 %}
        iif "{{ net_config.wan_if }}" ip6 daddr {{ ansible_default_ipv6.address |ipv6('wrap') }} tcp dport {{ ansible_port }} counter accept;
{%   endif %}
{% endif %}
        # disable access to cockpit console
        iif "{{ net_config.wan_if }}" tcp dport 9090 counter drop;
    }

    chain FORWARD {
        type filter hook forward priority 0; policy accept;

{% for machine in machines |dict2items %}
        iif "{{ net_config.wan_if }}" oif "{{ net_config.bridge }}" ip daddr {{ machine.value.net_config.address |ipv4('address') }} ct state {established, related} counter accept;
        oif "{{ net_config.wan_if }}" iif "{{ net_config.bridge }}" ip saddr {{ machine.value.net_config.address |ipv4('address') }} ct state {new, established, related} counter accept;
        iif "{{ net_config.wan_if }}" oif "{{ net_config.bridge }}" ip6 daddr {{ machine.value.net_config.address6 |ipv6('address') }} ct state {established, related} counter accept;
        oif "{{ net_config.wan_if }}" iif "{{ net_config.bridge }}" ip6 saddr {{ machine.value.net_config.address6 |ipv6('address') }} ct state {new, established, related} counter accept;

{%   for proto in machine.value.net_config.publish_ports %}
{%     for port in machine.value.net_config.publish_ports[proto] %}
{%       set out_port = (port |string).split( ':' )[0] %}
{%       set in_port  = (port |string).split( ':' )[1] |d(port |string) %}
{%       if 'address' in machine.value.net_config %}
        iif "{{ net_config.wan_if }}" oif "{{ net_config.bridge }}" ip daddr {{ machine.value.net_config.address |ipv4('address') }} {{ proto }} dport {{ in_port }} ct state {new, established, related} counter accept;
        oif "{{ net_config.wan_if }}" iif "{{ net_config.bridge }}" ip saddr {{ machine.value.net_config.address |ipv4('address') }} {{ proto }} sport {{ in_port  }} ct state {established, related} counter accept;
        iif "{{ net_config.wan_if }}" oif "{{ net_config.bridge }}" ip6 daddr {{ machine.value.net_config.address6 |ipv6('address') }} {{ proto }} dport {{ in_port }} ct state {new, established, related} counter accept;
        oif "{{ net_config.wan_if }}" iif "{{ net_config.bridge }}" ip6 saddr {{ machine.value.net_config.address6 |ipv6('address') }} {{ proto }} sport {{ in_port  }} ct state {established, related} counter accept;
{%       endif %}
{%     endfor %}
{%   endfor %}
{% endfor %}
    }

    chain OUTPUT {
        type filter hook output priority 0; policy accept;
    }
}

# vim: expandtab shiftwidth=4 tabstop=4
